''This object is intended for use with ProjectLine--UserInterfaceProp.spin 




''The video from this, the camera Prop, is fed to an external monitor for observation.

''This object acquires image data from the TSL sensors and displays the result on the video
''monitor, which you then use to focus your camera.

''Triggerin of the camera prop is wired to the triggerout of the interface prop... etc.
''The rest of the setup has been previously described...  (Of course:) some pin settings have changed.
''This pair of objects projects a blinking line.  The line blinks on... and a stereo image is taken.
''The screen is then cleared to black and another image is taken and subtracted from the original.
''This provides for a very useable signal.  
''As the lenses are rotated in or out... the resulting display will show an increasing signal
'' or a decreasing signal.
''The signal depends upon the integration time of the TSL and the brightness  of the projector at the distance
'' chosen.  Integration time is controlled through the TIP variable.   TIP should be in the range of 10 to 90_000.
''The range of pixel values displayed on the screen is controlled through the "range" variable.  If
''your signal saturates(reaches the top of the display area), increase your range variable... from 1 to 16 should
'' be adequate. 
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  x_tiles = 16
  y_tiles = 12

  paramcount = 14       
  bitmap_base = $2000
  display_base = $5000

  lines = 5
  thickness = 1
  bpin =20  'video basepine
  triggerOut = 1                       'triggerout

  tsl_clk  =8
  tsl_si   = 9
  mcp_clk  = 15
  mcp_data = 13
  mcp_cs   = 12
  triggerIn  = 2          'trigger in
  channel  = 0    'mcp base channel
  remote  = 4

VAR

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[16]
  long range,center,voffset,maxval,minval,cmd,t1,tip,maxdifflpix,noisefloor,temp,estimate_center

  long ok,sumdiffl,sumpixelindexL,sumdiffr,sumpixelindexR,Lpixel_Loc,Rpixel_Loc,docorr
  word maxR,maxL,maxL_loc ,maxR_loc
  long maxdiffrpix,aL,aR,aP,gotangle,pD,distance,lastdistance,lp1,lp2,rp1,rp2,Lcenterline,Rcenterline
  word dataL[128],dataR[128]     
OBJ
  tv    : "tv"
  gr    : "graphics2"
  MCP   : "MCP3208_fast_rjo"
  tsl   : "tsl1401asm_rjo_001"
PUB start | i,line,tempval1,yy,temploc1,temploc2,tempval2,char
  'io.start(10,11,0,115200)
  InitParams
  gr.start
  range:=10
  mcp.start(mcp_data,mcp_clk,mcp_cs)
  gr.setup(16, 12, 128, 96, bitmap_base)
  dira[tsl_clk]:=dira[tsl_si]:=1
  dira[triggerout]:=1
  cmd:=1
  tsl.start(@cmd)
  repeat until cmd == 0
  
  repeat
    if ina [triggerin]==1
        getimage
        outa[triggerout]:=1
        repeat until ina[triggerin]==0
           
            
   ' if ina[triggerin] == 0
        subtractimage
        plot
        outa[triggerout]:=0
        repeat until ina[triggerin]==1
           

pub getimage | i,tester
 cmd:=1

 repeat until cmd==0
 i:=0

 repeat 128
      outa[tsl_clk]:=1 
      outa[tsl_clk]:=0 
      datar[i]:=(mcp.in(channel))
      datal[i]:=(mcp.in(channel+1))
      i++

Pub InitParams   | i,dx,dy
  'range:=10
  Tip:=30000         'TSL integration period parameter....integration clocks =  3136 + (448*tip)
  voffset:=94    'adjusts plot x,y location.  Can be used in future to implement full windowing logic
  noisefloor:=50
  pD:=74
  longmove(@tv_status, @tvparams, paramcount)
  
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)
  repeat i from 0 to 16
    colors[i] := $00001010 * (i+20) & $F + $2B060C02
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)
                             
 
pub plot  |i, j,jj,k, kk,px,py,dechr,gotleft,gotright

    gr.clear
    gr.colorwidth(3,0)
    gr.colorwidth(2,0 )
   ' gr.text(64,80,@pchip)

    gr.colorwidth(2,0)
    repeat i from 0 to 126
      px:=i-128
      py:= ((dataL[i])/range)-voffset
      gr.plot(px,-voffset)
      gr.line(px,py)
      px:=i
      py:= ((datar[i])/range)-voffset
      gr.plot(px,-voffset)
      gr.line(px,py)                  
    gr.colorwidth(3,0)
    dechr:="L"
    gr.text(-64,-92,@dechr)
    dechr:="R"
    gr.text(64,-92,@dechr)
    gr.text(-90,80,@PixelVal)
    gr.text(-120,70,@LeftPixel_)
    gotleft:=1

               '
                                    't1 is total clocks in integration period, t1 is written by pasm routine
                                    'in tsl1401asm_rjo_001
    plotint(lPixel_loc,-40,70)
   ' plotint(101,-40,70)                'write integration period to screen

                   'write integration period to screen
    plotInt(range,-45,80)
    
    gr.color(2)

    gr.colorwidth(2,0)
    gr.copy(display_base)
Pub PlotColumn(whichline)

      gr.plot (whichline,-100)
      gr.line (whichline,100)
      gr.copy(display_base)


Pub plotInt (value,x,y) | i,kk,dechr,sign
    sign:="+"
    i:=0
    if value < 0
       value:=-value
       sign:="-"
                               
    repeat until value == 0
       kk:=value//10
       value:=value/10
       dechr:=num +kk
       gr.text(x-(i*6),y,@dechr)
       i:=i+1 
    gr.text(x-(i*6),y,@sign)

pub Blankscreen
    gr.clear
    gr.copy(display_base)    
pub update
    gr.copy(display_base)

Pub SubtractImage | i
 i:=0
 cmd:=1

 repeat until cmd==0

 repeat 128
      outa[tsl_clk]:=1 
      outa[tsl_clk]:=0 
      
      datal[i]:=||(datal[i]-(mcp.in(channel+1)) )
      datar[i]:=||(datar[i]-(mcp.in(channel)))
      i++
    
DAT

tvparams                long    0               'status
                        long    1               'enable
                        long     (bpin & $38) << 1 | (bpin & 4 == 4) & %0101 
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog

                        
Prop                    byte    "Propeller",0
LeftPixel_              byte    "Left Pixel=",0
PixelVal                byte    "Pix/ ",0
lp1_                    byte    "LP1 = ",0
lp2_                    byte    "LP2 = ",0
rp1_                    byte    "RP1 = ",0
rp2_                    byte    "RP2 = ",0
'pchip                   byte    "Propeller",0           'text
num                     byte    "0",0,"1",0,"2",0,"3",0,"4",0,"5",0,"6",0,"7",0,"8",0,"9",0